class EigenschaftsController < ApplicationController
  
  def new
    eigens(0)
    render :action    => 'edit'
  end  
  
  def list
    view_tree('Eigen')
    render :partial => "application/nav", :controller => "application"
  end
  
  def edit_called_by_tree
    info              = eigens(params[:idnr] )
    unless info.empty? 
      redirect_to :action => "message", :controller => 'application' , :confirm => info
    else
      render :action    => 'edit'
    end
  end

  # <b>update</b> aktualisiert den Datensatz
  
  def update
    info          = eigens(params[:id])
    unless info.empty?
      render :partial => "application/message", :locals => {:confirm => info}   
    else     
      if params[:todo]
        @eigen.destroy
        info                  = ['edit', 'hinweis', "Der Satz \"#{@eigen.name}\" wurde erfolgreich gel&ouml;scht" ]
        render :partial => "application/message", :locals => {:confirm => info, :function => { 'treelist'  => @view_name} }
      else
        do_save         # incl. render
      end
    end
  end

  # <b>reset</b> fhrt das Reset aus fr Edit-Templates aus
  
  def reset
    eigens(params[:id])
    render :partial => "edit", :locals => {:function => {'reset' => ''} }
  end

  # <b>art</b> prft das Feld "art"
  
  def art
    idnr      = params[:idnr] ? params[:idnr] : 0
    list_key  = params[:input]
    if idnr.to_i > 0              # nur bei vorhandenen Stzen erforderlich
      eigens(params[:idnr]) 
      @eigen.check = {'art', params[:input]}
      unless @eigen.valid?
        flash[:notice]  = @eigen.errors.on('art') 
        @html_flash     = @eigen.errors.count > 0 ? "<div class=\"popup_error\">#{flash[:notice]}</div>" : ""
        list_key        = @eigen.art
      end
    end      
    render :partial => "application/list",
                        :locals => {
		                    :liste => 'EigenArt', :listKey => list_key,
		                    :act => 'art', :cont => 'eigenschafts', :idnr => idnr
		                    }
  end   

  # <b>droptext</b> ermittelt die Drop-Texte
  
  def droptext(id, index, dropped)
    
    @eigen = Eigenschaft.find(id)   unless @eigen

    gruppe          = @eigen.gruppe(dropped)
    result          = gruppe.nil? ? ['', '', 0] : [gruppe.name, gruppe.beschreibung, gruppe.id]
    result          << "Um die Gruppeneigenschaft zu &auml;ndern, einfach dieses Icon auf die neue Eigenschaft ziehen"
    result          << "L&ouml;scht die Eigenschaft"
    result          << (@eigen.verwendung.empty?   ?  '': 'hide' )
    result
  end
   
  ######################################################################################################    
  
  private
    
  # <b>dropped</b> bearbeitet den Drag-Drop-Vorgang

  def dropped(view, dropped, idnr)
    if view && view != 'NaviSeite-2'
      flash[:notice]  = 'Es wurde die &Auml;nderung einer Eigenschaft angefordert. Bitte in die Anzeige f&uuml;r Eigenschaften wechseln.' 
      msg             = "<div class=\"popup_error\">#{flash[:notice]}</div>"
    else
      info = eigens(idnr[0].to_i)
      if info.empty?        
        if dropped.to_i > 0 
          @eigen.check     = {'gruppeneigenschaft', dropped}
          ok                = @eigen.valid?
        else
          dropped           = 0
          ok                = true
        end
        if @new || ok
          @dropdrag[0]    = dropped 
        else
          flash[:notice]  = @eigen.errors.on('gruppeneigenschaft') 
          msg             = @eigen.errors.count > 0 ? "<div class=\"popup_error\">#{flash[:notice]}</div>" : ""
        end    
      else
        flash[:notice]  = "Der Vorgang konnte f&uuml;r diese Eigenschaft aus folgendem Grund nicht ausgef&uuml;hrt werden:<br>" + info[2]
        msg             = "<div class=\"popup_error\">#{flash[:notice]}</div>"   
      end 
    end
    return [@dropdrag, msg]               
  end
  
  # <b>do_save</b> fhrt die Prfungen und Aktualisierungen fr update und new aus
  
  def do_save
    dropped         = params[:drop_mem_0]         # Name des Hidden-Feldes
    @eigen.check   = { 'art' => Liste.new('EigenArt', params[:idList]).key,
                        'gruppeneigenschaft' => dropped}
    
    name            = @eigen.name
    gruppe          = @eigen.gruppeneigenschaft
    
    @eigen.attributes = params[:eigen]
    if @eigen.valid?   # setzt ber call_record auch die attribute von @check
      @eigen.save(gruppe, true)
      @dropdrag     = [@eigen.gruppeneigenschaft]        # Aktualisierung der Instanzvariablen
 
      if !@new && (gruppe != @eigen.gruppeneigenschaft || name != @eigen.name)   # im Falle von new: s. function['treelist]
        view_tree("Eigen", "", "clear")
      end
      
      # Rendering - im Falle von "neu" wird nicht neu geladen, da dies den Aufruf zur Neuerstellung wiederholt
      function        = {}      # Javascript-Funktionen fr Rendering
      unless @new
        function['reload']    = ''                # liest die gesamte Seite neu ein, um auch die Ajax-Werte "festzuschreiben"       
      else
        eigens(0)                                 # bereinigt die Dateifelder
        function['reset']     = ''                # bereinigt die Browserfelder
        function['treelist']  = @view_name        # bereitet die Treelist neu auf
      end        
      render :partial => "edit", :locals => {:function => function}    

    else        # Fehler
      notice, msg           = "", []
      @eigen.errors.each {|attr, msg| notice << "#{msg}<br>"}
      confirm               = ['edit', 'error', notice ]
      render :partial => "edit", :locals => {:confirm => confirm}  
    end
  end
  
  # <b>eigens</b> ermittelt den Satz, bestimmt die Werte bei neu anzulegenden oder gibt Fehler aus

  def eigens(id, todo = '')
    info                    = []
    if id.to_i == 0         # neuer Satz
      @eigen               = Eigenschaft.new     
      @eigen.name          = 'neu'
      @eigen.beschreibung  = 'neue Eigenschaft'
      @eigen.id            = 0
    else
      begin
        @eigen             = Eigenschaft.find(id)  if id.to_i > 0
      rescue
        notice              = "Die angeforderte Eigenschaft mit der Satznummer \"#{id}\" konnte nicht gefunden werden. 
                              Dies k&ouml;nnte daran liegen, dass Sie auf einen &uuml;berholten Stand der Anzeige gebl&auml;ttert haben 
                              und l&auml;sst sich durch \"Neuladen\" des Browsers bereinigen.
                              Bitte w&auml;hlen Sie eine andere Eigenschaft aus."
        if todo.empty?
          eigens(0)           # edit mit neuem Satz ausgeben: stellt "ungefhrliches" @eigen sicher
        elsif todo == '-1'
          notice  = ''
          eigens(id.to_i-1, todo)
        end
        info                = ['edit', 'error', notice ]    unless notice.empty?
      end
    end
    
    # Ergebnisse
    if @eigen
      @dropdrag   = [@eigen.gruppeneigenschaft]
      @new        = @eigen.new_record? ? true : false
    end
    info
  end  
  
end
