
# <b>Eigenschaft</b> regelt die Zugriffe auf die Datei "eigenschafts" der Eigenschaften sowie
# die Aktionen und sonstigen Informationen, die im Zusammenhang damit stehen 
#
# auftretende Fehler werden dabei idR. als Programmierfehler betrachtet: keine Ausgabe ber @notice

class Eigenschaften

  attr_reader :data, :treelist, :view_name, :treelist_header, :notice, :info

  # <b>initialize</b> liest die Daten der Datei ein und speichert sie.
  # Die eingelesenen Daten werden gem den Treelist-Anforderungen (#tree) aufbereitet
  
  def initialize(*parms)
    @@data      = {}    if !defined?(@@data) 
    @view_name  = "NaviSeite-2"
    clear       = parms[0] ? parms[0] : ''
    
    if @@data.key?(@view_name) && clear.empty?
      @treelist = @@data[@view_name]
      treelist_head   unless @treelist_header
    else
      datei_to_tree                       # Einlesen der datei-Datenstze  
    end
  end
  
  ######################################################################################################   
 
  private  

  # <b>datei_to_tree</b> liest die Datenstze aus der Datei ein und
  # bereitet die eingelesene Datenliste fr die Treelist-Anzeige auf
  
  def datei_to_tree
    @treelist = do_group
    @@data[@view_name]  = @treelist
    treelist_head
   end
  
  ######## 2. Level    
  
  # <b>do_group</b> arbeitet die hinterlegte Treelist auf
  #
  # fr Treelist: Feldnamen plus Feldinfo, aufbereitet fr treelist_helper 
  # * sort       : Sortiermerkmal
  # * Array      : standardisierte Form (Info-Array)
  #   1. Array[0]: key           - anzuzeigendes Element
  #   2. Array[1]: Hash          - enthlt den nchsten Zweig, falls vorhanden
  #   3. Array[2]: Array         - URL/Name des Icons, Alt/Tooltip zum Image
  #   4. Array[3]: Array         - Aktion und Controller
  #   5. Array[4]: Array         - Satznummer, Fehler-Icon, Fehler-Text
  #   6. Array[5]: Array         - enthlt weitere Informationen fr Tooltips, Rechte Maus    

  def do_group(*parent)
    items   = {}
    
    # passende Datenstze finden
    if parent.empty?
      group = Eigenschaft.find_all_by_gruppeneigenschaft(0)
    else
      group = parent[0].children
    end
    
    # Aufbereiten der Hierarchie
    icon    = []              # Arrays der weiteren Informationen
    action  = ["edit_called_by_tree", "eigenschafts"]  # Verarbeitung auf Datei-Ebene
    
    group.each do |member|
      items[member.name] = [member.name, do_group(member), icon, action, [member.id], [member.beschreibung]]       # Array: key, Hash, Icon-Array, Action-Array, Info-Array
      end
    items
  end
   
  ######## Vorgaben
      
  # <b>treelist_head</b> bereitet die Kopfinformationen der Treelist auf
  
  def treelist_head
    @treelist_header    = []
    @treelist_header[0] = "Eigenschaften"                         # Root-Name
    @treelist_header[1] = ["tree/root.png", "Eigenschaften"]      # icon, alt/tooltip 
    @treelist_header[2] = []                                      # keine Verarbeitung auf Root-Ebene
  end

end