class Datei < ActiveRecord::Base

  include Models_modul
  
  # Standard-Validierungen
  
  validates_presence_of :beschreibung , :modul

  # <b>refresh_gewicht</b> korrigiert ggf. die Typgewichte
  
  def Datei.refresh_gewicht(db)
    if db.empty?
      all         = find(:all)
    else
      all         = find(:all, :conditions => "datenbank = '#{db}'")
    end
    all.each do |datei|
      datei.save          # Validierung korrigiert Typgewicht
      end
  end
 
  ######################################################################################################    
  
  private  
  
  # <b>calc_conseq</b arbeitet den gesamten Datensatz ab und bestimmt rechnerische Konsequenzen
  # ! Voraussetzung ist, dass die validate-Feld-Prfungen erfolgt sind
 
  def calc_conseq(attr, store, cond)

    if store
      felds = Feld.find_all_by_datei(self.id)     # nicht weiter einschrnken (ist Aufgabe von "Feld")
      typ   = 0.0
      felds.each do |feld|
        typ += feld.relativgewicht
        end
    end
    attr['typgewicht']  = typ 
    attr
  end
   
  def classifier_ok?(check, cond)         # alle Felder sind als Methoden bereits angelegt: Der Call darauf gibt den Feldwert zurck
    return ''     if check.to_s.empty?
    begin
      found = Marshal.load(self.fields)[0][1].include?(check)
    rescue
      found = true                  # wenn Marshal nicht erfolgreich ist, heit dies, dass keine Felddaten vorhanden sind
    end    
    unless found
      @errors.add("classifier", "Der Klassifizierer \"#{check}\" muss ein Dateifeld sein") 
      check = ''
    end
    check
  end  
      
end
